$ontext
Copyright (C)   2007 Shiro Takeda
Time-stamp: 	<2008-06-03 18:18:12 Shiro Takeda>
$Id$
version:
Author: 	Shiro Takeda <zbc08106@park.zero.ad.jp>
e-mail:		<zbc08106@park.zero.ad.jp>
First-written:	<2007/10/14>

$offtext

*	----------------------------------------------------------------------
*	Results:
if(fl_bau,

    chk_walras(r,"bau") = 100 * m_h.m(r) / m_h.l(r);

*	Consumption:
    l_c(r,"bau") = q_c.l(r);
    l_c("sum","bau") = sum(r, l_c(r,"bau"));

*	EV:
    l_ev(r,"bau") = (u.l(r) - 1) * (hexp0(r)$(not fix_inv) + c0(r)$fix_inv);
    l_ev("sum","bau") = sum(r, l_ev(r,"bau"));

*	Utility:
    l_u(r,"bau") = (hexp0(r)$(not fix_inv) + c0(r)$fix_inv) * u.l(r);
    l_u("sum","bau") = sum(r, l_u(r,"bau"));

*	Savings:
    l_save(r,"bau") = q_save.l(r)$(not fix_inv) + (s_f*inv0(r))$fix_inv;
    l_save("sum","bau") = sum(r, l_save(r,"bau"));

*	Government expenditure:
    l_gov(r,"bau") = q_gov.l(r);
    l_gov("sum","bau") = sum(r, l_gov(r,"bau"));

*	Export:
    l_exp_r(r,"bau") = sum(i, ex0(i,r) * ex.l(i,r));

*	Import
    l_imp_r(r,"bau") = sum(i, imw0(i,r) * im.l(i,r));

*	Export by goods:
    l_exp_g(i,"bau") = sum(r, ex0(i,r) * ex.l(i,r));

*	Import by goods
    l_imp_g(i,"bau") = sum(r, imw0(i,r) * im.l(i,r));

*	Production level:
    l_y(i,r,"bau") = y0(i,r) * y.l(i,r);

*	Transfer to regions:
    l_trans(r,"bau") = trn0(r) * c_endow.l;
    l_trans("sum","bau") = sum(r, l_trans(r,"bau"));

*	Factor prices:
    l_pl(r,"bau") = pl.l(r) / pu.l(r);
    l_pk(r,"bau") = pk.l(r) / pu.l(r);
    l_pland(r,"bau") = pland.l("agr",r) / pu.l(r);

*	External TOT:
    l_sh_ex(i,r,"bau") = px.l(i,r) * q_ex.l(i,r) / sum(ii, px.l(ii,r) * q_ex.l(ii,r));
    l_sh_im(i,r,"bau") = pfx.l * q_im.l(i,r) / sum(ii, pfx.l * q_im.l(ii,r));
    l_p_ex(r,"bau") = prod(i$ex0(i,r), px.l(i,r)**(sum(scn, 0.5*l_sh_ex(i,r,scn))));
    l_p_im(r,"bau") = prod(i$im0(i,r), pfx.l**(sum(scn, 0.5*l_sh_im(i,r,scn))));
    l_tot(r,"bau") = l_p_ex(r,"bau") / l_p_im(r,"bau");

*	TOT (including domestic trade):
    l_sh_ex_alt(i,r,"d","bau")
	= pd.l(i,r) * sum(s$r_s(r,s), q_a_d.l(i,r,s))
	    / (sum(ii, px.l(ii,r) * q_ex.l(ii,r)
		+ sum(s$r_s(r,s), pd.l(ii,r) * q_a_d.l(ii,r,s))));
    l_sh_ex_alt(i,r,"f","bau")
	= px.l(i,r) * q_ex.l(i,r)
	    / (sum(ii, px.l(ii,r) * q_ex.l(ii,r)
		+ sum(s$r_s(r,s), pd.l(ii,r) * q_a_d.l(ii,r,s))));
    l_sh_im_alt(i,s,r,"bau")
	= (pd.l(i,s) * q_a_d.l(i,s,r))
	/ (sum(ii, pfx.l * q_im.l(ii,r)
	    + sum(rr$r_s(r,rr), pd.l(ii,rr) * q_a_d.l(ii,rr,r))));
    l_sh_im_alt(i,"f",r,"bau")
	= (pfx.l * q_im.l(i,r))
	/ (sum(ii, pfx.l * q_im.l(ii,r)
	    + sum(rr$r_s(r,rr), pd.l(ii,rr) * q_a_d.l(ii,rr,r))));
    l_p_ex_alt(r,"bau") =
	prod(i$ex0(i,r), px.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"f",scn))))
	* prod(i$l_sh_ex_alt(i,r,"d","bau"), pd.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"d",scn))));
    l_p_im_alt(r,"bau") =
	prod(i$im0(i,r), pfx.l**(sum(scn, 0.5*l_sh_im_alt(i,"f",r,scn))))
	* prod((i,s)$l_sh_im_alt(i,s,r,"bau"), pd.l(i,s)**(sum(scn, 0.5*l_sh_im_alt(i,s,r,scn))));
    l_tot_alt(r,"bau") = l_p_ex_alt(r,"bau") / l_p_im_alt(r,"bau");

*	GDP (value added):
    l_vgdp_va(r,"bau")
	= sum(j, pal.l(j,r) * q_al.l(j,r) + pak.l(j,r) * q_ak.l(j,r)
	    + taxy0(j,r) * ((px.l(j,r) * q_es.l(j,r))$ex0(j,r) + pd.l(j,r) * q_ds.l(j,r)));
    l_vgdp_va("sum","bau") = sum(r, l_vgdp_va(r,"bau"));

*	Decomposition of utility change:
    l_u_decomp(r,"finc","bau")
	= (pl.l(r) * s_f * lab0(r) + pk.l(r) * s_f * cap0(r)) / pu.l(r);
    l_u_decomp(r,"trns","bau")
	= (sum(rnum, pc.l(rnum)) * trn0(r) * c_endow.l) / pu.l(r);
    l_u_decomp(r,"oth","bau")
	= - pfx.l * s_f * bop0(r) / pu.l(r);
    l_u_decomp(r,"sum","bau")
	= l_u_decomp(r,"finc","bau") + l_u_decomp(r,"trns","bau") + l_u_decomp(r,"oth","bau");
    l_u_decomp("sum","finc","bau") = sum(r, l_u_decomp(r,"finc","bau"));
    l_u_decomp("sum","trns","bau") = sum(r, l_u_decomp(r,"trns","bau"));
    l_u_decomp("sum","oth","bau") = sum(r, l_u_decomp(r,"oth","bau"));
    l_u_decomp("sum","sum","bau") = sum(r, l_u_decomp(r,"sum","bau"));

*	
    l_u_sh(r,"finc","bau")
	= l_u_decomp(r,"finc","bau") / l_u_decomp(r,"sum","bau");
    l_u_sh(r,"trns","bau")
	= l_u_decomp(r,"trns","bau") / l_u_decomp(r,"sum","bau");
    l_u_sh(r,"oth","bau")
	= l_u_decomp(r,"oth","bau") / l_u_decomp(r,"sum","bau");
    l_u_sh("sum","finc","bau")
	= l_u_decomp("sum","finc","bau") / l_u_decomp("sum","sum","bau");
    l_u_sh("sum","trns","bau")
	= l_u_decomp("sum","trns","bau") / l_u_decomp("sum","sum","bau");
    l_u_sh("sum","oth","bau")
	= l_u_decomp("sum","oth","bau") / l_u_decomp("sum","sum","bau");

*	BOP:
    l_bop(r,"bau") =
	sum(i$ex0(i,r), e_tot(i,r) * e_trade(i,r) * ex0(i,r) * ex_.l(i,r))
	- sum(i$im0(i,r), im0(i,r) * im_.l(i,r));
    l_bop("sum","bau") = sum(r, l_bop(r,"bau"));

*	GDP (expenditure side):
    l_vgdp(r,"bau") =
	pc.l(r) * q_c.l(r)
	+ pgov.l(r) * q_gov.l(r)
	+ pinv.l(r) * q_inv.l(r)
	+ pfx.l * sum(i, q_exx.l(i,r))
	- sum(i, pm.l(i,r) * q_imw.l(i,r))
	+ sum((i,s)$r_s(r,s), pd.l(i,r) * q_a_d.l(i,r,s))
	- sum((i,s)$r_s(r,s), pd.l(i,s) * q_a_d.l(i,s,r))
	;
    l_vgdp("sum","bau") = sum(r, l_vgdp(r,"bau"));

*	Real GDP:
    l_qgdp(r,"bau") =
	q_c.l(r)
 	+ q_gov.l(r)
	+ q_inv.l(r)
	+ sum(i, q_exx.l(i,r))
	- sum(i, q_im.l(i,r))
	+ sum((i,s)$r_s(r,s), q_a_d.l(i,r,s))
	- sum((i,s)$r_s(r,s), q_a_d.l(i,s,r));
    l_qgdp("sum","bau") = sum(r, l_qgdp(r,"bau"));

*	Price index of GDP (derived implicitly):
    l_pgdp(r,"bau") = l_vgdp(r,"bau") / l_qgdp(r,"bau");

*	Decomposition of GDP change:
    l_qgdp_decomp_ele(r,"con","bau") = q_c.l(r);
    l_qgdp_decomp_ele(r,"gov","bau") = q_gov.l(r);
    l_qgdp_decomp_ele(r,"inv","bau") = q_inv.l(r);
    l_qgdp_decomp_ele(r,"exp","bau") = sum(i, q_exx.l(i,r));
    l_qgdp_decomp_ele(r,"imp","bau") = - sum(i, q_im.l(i,r));
    l_qgdp_decomp_ele(r,"out","bau")
	= sum((i,s)$r_s(r,s), q_a_d.l(i,r,s));
    l_qgdp_decomp_ele(r,"in","bau")
	= - sum((i,s)$r_s(r,s), q_a_d.l(i,s,r));
    l_qgdp_decomp_ele(r,"sum","bau")
	= sum(ele_gdp, l_qgdp_decomp_ele(r,ele_gdp,"bau"));
    l_qgdp_decomp_ele("sum",ele_gdp,"bau")  = sum(r, l_qgdp_decomp_ele(r,ele_gdp,"bau"));
    l_qgdp_decomp_ele("sum","sum","bau")  = sum((r,ele_gdp), l_qgdp_decomp_ele(r,ele_gdp,"bau"));

else

    chk_walras(r,"cf") = 100 * m_h.m(r) / m_h.l(r);

*	Consumption:
    l_c(r,"cf") = q_c.l(r);
    l_c("sum","cf") = sum(r, l_c(r,"cf"));

*	EV:
    l_ev(r,"cf") = (u.l(r) - 1) * (hexp0(r)$(not fix_inv) + c0(r)$fix_inv);
    l_ev("sum","cf") = sum(r, l_ev(r,"cf"));

*	Utility:
    l_u(r,"cf") = (hexp0(r)$(not fix_inv) + c0(r)$fix_inv) * u.l(r);
    l_u("sum","cf") = sum(r, l_u(r,"cf"));

*	Savings:
    l_save(r,"cf") = q_save.l(r)$(not fix_inv) + (s_f*inv0(r))$fix_inv;
    l_save("sum","cf") = sum(r, l_save(r,"cf"));

*	Government expenditure:
    l_gov(r,"cf") = q_gov.l(r);
    l_gov("sum","cf") = sum(r, l_gov(r,"cf"));

*	Export:
    l_exp_r(r,"cf") = sum(i, ex0(i,r) * ex.l(i,r));

*	Import
    l_imp_r(r,"cf") = sum(i, imw0(i,r) * im.l(i,r));

*	Export by goods:
    l_exp_g(i,"cf") = sum(r, ex0(i,r) * ex.l(i,r));

*	Import by goods
    l_imp_g(i,"cf") = sum(r, imw0(i,r) * im.l(i,r));

*	Production level:
    l_y(i,r,"cf") = y0(i,r) * y.l(i,r);

*	Transfer to regions:
    l_trans(r,"cf") = trn0(r) * c_endow.l;
    l_trans("sum","cf") = sum(r, l_trans(r,"cf"));

*	Factor prices:
    l_pl(r,"cf") = pl.l(r) / pu.l(r);
    l_pk(r,"cf") = pk.l(r) / pu.l(r);
    l_pland(r,"cf") = pland.l("agr",r) / pu.l(r);

*	External TOT:
    l_sh_ex(i,r,"cf") = px.l(i,r) * q_ex.l(i,r) / sum(ii, px.l(ii,r) * q_ex.l(ii,r));
    l_sh_im(i,r,"cf") = pfx.l * q_im.l(i,r) / sum(ii, pfx.l * q_im.l(ii,r));
    l_p_ex(r,"cf") = prod(i$ex0(i,r), px.l(i,r)**(sum(scn, 0.5*l_sh_ex(i,r,scn))));
    l_p_im(r,"cf") = prod(i$im0(i,r), pfx.l**(sum(scn, 0.5*l_sh_im(i,r,scn))));
    l_tot(r,"cf") = l_p_ex(r,"cf") / l_p_im(r,"cf");

*	TOT (including domestic trade):
    l_sh_ex_alt(i,r,"d","cf")
	= pd.l(i,r) * sum(s$r_s(r,s), q_a_d.l(i,r,s))
	    / (sum(ii, px.l(ii,r) * q_ex.l(ii,r)
		+ sum(s$r_s(r,s), pd.l(ii,r) * q_a_d.l(ii,r,s))));
    l_sh_ex_alt(i,r,"f","cf")
	= px.l(i,r) * q_ex.l(i,r)
	    / (sum(ii, px.l(ii,r) * q_ex.l(ii,r)
		+ sum(s$r_s(r,s), pd.l(ii,r) * q_a_d.l(ii,r,s))));
    l_sh_im_alt(i,s,r,"cf")
	= (pd.l(i,s) * q_a_d.l(i,s,r))
	/ (sum(ii, pfx.l * q_im.l(ii,r)
	    + sum(rr$r_s(r,rr), pd.l(ii,rr) * q_a_d.l(ii,rr,r))));
    l_sh_im_alt(i,"f",r,"cf")
	= (pfx.l * q_im.l(i,r))
	/ (sum(ii, pfx.l * q_im.l(ii,r)
	    + sum(rr$r_s(r,rr), pd.l(ii,rr) * q_a_d.l(ii,rr,r))));
    l_p_ex_alt(r,"cf") =
	prod(i$ex0(i,r), px.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"f",scn))))
	* prod(i$l_sh_ex_alt(i,r,"d","cf"), pd.l(i,r)**(sum(scn, 0.5*l_sh_ex_alt(i,r,"d",scn))));
    l_p_im_alt(r,"cf") =
	prod(i$im0(i,r), pfx.l**(sum(scn, 0.5*l_sh_im_alt(i,"f",r,scn))))
	* prod((i,s)$l_sh_im_alt(i,s,r,"cf"), pd.l(i,s)**(sum(scn, 0.5*l_sh_im_alt(i,s,r,scn))));
    l_tot_alt(r,"cf") = l_p_ex_alt(r,"cf") / l_p_im_alt(r,"cf");

*	GDP (value added):
    l_vgdp_va(r,"cf")
	= sum(j, pal.l(j,r) * q_al.l(j,r) + pak.l(j,r) * q_ak.l(j,r)
	    + taxy0(j,r) * ((px.l(j,r) * q_es.l(j,r))$ex0(j,r) + pd.l(j,r) * q_ds.l(j,r)));
    l_vgdp_va("sum","cf") = sum(r, l_vgdp_va(r,"cf"));

*	Decomposition of utility change:
    l_u_decomp(r,"finc","cf")
	= (pl.l(r) * s_f * lab0(r) + pk.l(r) * s_f * cap0(r)) / pu.l(r);
    l_u_decomp(r,"trns","cf")
	= (sum(rnum, pc.l(rnum)) * trn0(r) * c_endow.l) / pu.l(r);
    l_u_decomp(r,"oth","cf")
	= - pfx.l * s_f * bop0(r) / pu.l(r);
    l_u_decomp(r,"sum","cf")
	= l_u_decomp(r,"finc","cf") + l_u_decomp(r,"trns","cf") + l_u_decomp(r,"oth","cf");
    l_u_decomp("sum","finc","cf") = sum(r, l_u_decomp(r,"finc","cf"));
    l_u_decomp("sum","trns","cf") = sum(r, l_u_decomp(r,"trns","cf"));
    l_u_decomp("sum","oth","cf") = sum(r, l_u_decomp(r,"oth","cf"));
    l_u_decomp("sum","sum","cf") = sum(r, l_u_decomp(r,"sum","cf"));

*	
    l_u_sh(r,"finc","cf")
	= l_u_decomp(r,"finc","cf") / l_u_decomp(r,"sum","cf");
    l_u_sh(r,"trns","cf")
	= l_u_decomp(r,"trns","cf") / l_u_decomp(r,"sum","cf");
    l_u_sh(r,"oth","cf")
	= l_u_decomp(r,"oth","cf") / l_u_decomp(r,"sum","cf");
    l_u_sh("sum","finc","cf")
	= l_u_decomp("sum","finc","cf") / l_u_decomp("sum","sum","cf");
    l_u_sh("sum","trns","cf")
	= l_u_decomp("sum","trns","cf") / l_u_decomp("sum","sum","cf");
    l_u_sh("sum","oth","cf")
	= l_u_decomp("sum","oth","cf") / l_u_decomp("sum","sum","cf");

*	BOP:
    l_bop(r,"cf") =
	sum(i$ex0(i,r), e_tot(i,r) * e_trade(i,r) * ex0(i,r) * ex_.l(i,r))
	- sum(i$im0(i,r), im0(i,r) * im_.l(i,r));
    l_bop("sum","cf") = sum(r, l_bop(r,"cf"));

*	GDP (expenditure side):
    l_vgdp(r,"cf") =
	pc.l(r) * q_c.l(r)
	+ pgov.l(r) * q_gov.l(r)
	+ pinv.l(r) * q_inv.l(r)
	+ pfx.l * sum(i, q_exx.l(i,r))
	- sum(i, pm.l(i,r) * q_imw.l(i,r))
	+ sum((i,s)$r_s(r,s), pd.l(i,r) * q_a_d.l(i,r,s))
	- sum((i,s)$r_s(r,s), pd.l(i,s) * q_a_d.l(i,s,r))
	;
    l_vgdp("sum","cf") = sum(r, l_vgdp(r,"cf"));

*	Real GDP:
    l_qgdp(r,"cf") =
	q_c.l(r)
 	+ q_gov.l(r)
	+ q_inv.l(r)
	+ sum(i, q_exx.l(i,r))
	- sum(i, q_im.l(i,r))
	+ sum((i,s)$r_s(r,s), q_a_d.l(i,r,s))
	- sum((i,s)$r_s(r,s), q_a_d.l(i,s,r));
    l_qgdp("sum","cf") = sum(r, l_qgdp(r,"cf"));

*	Price index of GDP (derived implicitly):
    l_pgdp(r,"cf") = l_vgdp(r,"cf") / l_qgdp(r,"cf");

*	Decomposition of GDP change:
    l_qgdp_decomp_ele(r,"con","cf") = q_c.l(r);
    l_qgdp_decomp_ele(r,"gov","cf") = q_gov.l(r);
    l_qgdp_decomp_ele(r,"inv","cf") = q_inv.l(r);
    l_qgdp_decomp_ele(r,"exp","cf") = sum(i, q_exx.l(i,r));
    l_qgdp_decomp_ele(r,"imp","cf") = - sum(i, q_im.l(i,r));
    l_qgdp_decomp_ele(r,"out","cf")
	= sum((i,s)$r_s(r,s), q_a_d.l(i,r,s));
    l_qgdp_decomp_ele(r,"in","cf")
	= - sum((i,s)$r_s(r,s), q_a_d.l(i,s,r));
    l_qgdp_decomp_ele(r,"sum","cf")
	= sum(ele_gdp, l_qgdp_decomp_ele(r,ele_gdp,"cf"));
    l_qgdp_decomp_ele("sum",ele_gdp,"cf")  = sum(r, l_qgdp_decomp_ele(r,ele_gdp,"cf"));
    l_qgdp_decomp_ele("sum","sum","cf")  = sum((r,ele_gdp), l_qgdp_decomp_ele(r,ele_gdp,"cf"));

);

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* End:
